> For the complete documentation index, see [llms.txt](https://docs.rasgoml.com/rasgo-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rasgoml.com/rasgo-docs/rasgo-0.1/all-transforms/timeseries_agg.md).

# Timeseries Agg

Date-based; Calculates a rolling aggregate based on a relative datetime window.

Pass in a date column, date\_part and offsets to create look-back or look-forward windows.

Example use case: Aggregate all sales for a product with order dates within 2 months of this current order.

## Parameters

| Name         | Type         | Description                                                                                                                                                                               | Is Optional |
| ------------ | ------------ | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------- |
| aggregations | agg\_dict    | Dictionary of columns and aggregate functions to apply. A column can have a list of multiple aggregates applied. One column will be created for each column:aggregate pair.               |             |
| date         | column       | Column used to calculate the time window for aggregation                                                                                                                                  |             |
| offsets      | int\_list    | List of numeric values to offset the date column Positive values apply a look-back window. Negative values apply a look-forward window. One column will be created for each offset value. |             |
| date\_part   | date\_part   | Valid SQL date part to describe the grain of the date\_offset                                                                                                                             |             |
| group\_by    | column\_list | Column(s) to group by when calculating the agg window                                                                                                                                     | True        |

## Example

```python
internet_sales = rasgo.get.dataset(74)

ds = internet_sales.timeseries_agg(
        aggregations={
          "SALESAMOUNT": ['SUM', 'MIN', 'MAX']
        },
        group_by=['PRODUCTKEY'],
        date='ORDERDATE',
        offsets=[-7, -14, 7, 14],
        date_part='MONTH'
       )

```

## Source Code

{% embed url="<https://github.com/rasgointelligence/RasgoTransforms/blob/main/rasgotransforms/rasgotransforms/transforms/timeseries_agg/snowflake/timeseries_agg.sql>" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rasgoml.com/rasgo-docs/rasgo-0.1/all-transforms/timeseries_agg.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
